package jds.redio;

import net.minecraft.block.Block;
import net.minecraft.item.ItemStack;
import net.minecraftforge.common.Configuration;
import cpw.mods.fml.common.Mod;
import cpw.mods.fml.common.Mod.EventHandler;
import cpw.mods.fml.common.SidedProxy;
import cpw.mods.fml.common.Mod.Init;
import cpw.mods.fml.common.Mod.Instance;
import cpw.mods.fml.common.Mod.PostInit;
import cpw.mods.fml.common.Mod.PreInit;
import cpw.mods.fml.common.event.FMLInitializationEvent;
import cpw.mods.fml.common.event.FMLPostInitializationEvent;
import cpw.mods.fml.common.event.FMLPreInitializationEvent;
import cpw.mods.fml.common.network.NetworkMod;
import cpw.mods.fml.common.registry.GameRegistry;
import cpw.mods.fml.common.registry.LanguageRegistry;
import cpw.mods.fml.relauncher.Side;
import cpw.mods.fml.relauncher.SideOnly;

@Mod(modid="RedIO", name="RedIO", version="1.1",  dependencies = "after:ComputerCraft;after:CCTurtle")
@NetworkMod(clientSideRequired=true, serverSideRequired=false)

public class RedIO 
{
	// this was 15 min of work.
	@Instance("RedIO")
	public static RedIO instance;

	@SidedProxy(clientSide="jds.redio.ClientProxy", serverSide="jds.redio.CommonProxy")

	public static CommonProxy proxy;
	public static ClientProxy cproxy;
	public static int redioID;
	public static Configuration config;
	
	@EventHandler 
	public void preInit(FMLPreInitializationEvent event) 
	{
		config = new Configuration(event.getSuggestedConfigurationFile());
		config.load();
		redioID = config.getBlock("RedIO", 2300).getInt();
		config.save();
	}
	
	public static Block redstoneio;
	
	@EventHandler 
	public void load(FMLInitializationEvent event) 
	{
		redstoneio = new BlockIO(redioID).setUnlocalizedName("RedstoneIO");
		GameRegistry.registerBlock(redstoneio, "RedstoneIO");
		LanguageRegistry.addName(redstoneio, "Redstone I/O");
		GameRegistry.registerTileEntity(TileEntityIO.class, "RedIOTile");
		
		ItemStack redioblock = new ItemStack(redioID, 1, 0);
		ItemStack stone = new ItemStack(Block.stone, 1, 0);
		ItemStack rsblock = new ItemStack(Block.blockRedstone, 1, 0);
		GameRegistry.addRecipe(redioblock, "SSS", "SRS", "SSS", 'S', stone, 'R', rsblock);
	}
	
	@EventHandler 
	@SideOnly(Side.CLIENT)
	public void postInit(FMLPostInitializationEvent event) 
	{
		// Stub Method
		//Config.getArmorList();
		//amorTextureUtil.getAList();
		
	}
}
